#include "disp.h"

void Display::refresh_screen (char ips[LEFT_PANEL][255], char dst[RIGHT_PANEL][255], 
	int ips_count, int dst_count, int ips_index, int dst_index, int cur_panel)	
	{

	int i;	
	int page=0;
   printf("\033[00;36;40m");
	fflush(stdout);
//	display_header();
//printf("%x\n", ips_count);	
//fflush(stdout);

	int rows_per_page = term.rows-5;
	int j=0, start, end;
	while (j<ips_count)	{
		if (j>ips_index) break;
		j+=rows_per_page;	
		page++;
		}
	page--;
	start = page * rows_per_page;
	end = (start + rows_per_page > ips_count) ? ips_count : start + rows_per_page;
	j=0;
	for (i=start;i<end;i++)	{ // rysuje adresy ip
		term.goto_xy(PANEL_LEFT_X,PANEL_LEFT_Y+j);
		
		if (i==ips_index) {
			if (cur_panel==0) printf("\033[01;37;46m%s\033[00;36;40m",*(ips+i));
			else printf("\033[00;30;46m%s\033[00;36;40m",*(ips+i));
			}
		else printf("%s",*(ips+i));
		fflush(stdout);
		j++;
		}
		
	j=0;
	
	while (j<dst_count)	{
		if (j>dst_index)	break;
		j+=rows_per_page;
		page++;
		}
	page--;	

	start = page * rows_per_page;
	end = (start + rows_per_page > dst_count) ? dst_count : start + rows_per_page;
	j=0;
	for (i=start;i<end;i++)	{
		term.goto_xy(PANEL_RIGHT_X, PANEL_RIGHT_Y+j);
		if (i==dst_index) {
			if (cur_panel==1) printf("\033[01;37;46m%s\033[00;36;40m",*(dst+i));
			else printf("\033[00;30;46m%s\033[00;36;40m",*(dst+i));
			}
		else printf("%s",*(dst+i));
		fflush(stdout);
		j++;
		}
}

void Display::clear_panels(int ips_count, int dst_count)	{
	int i,j;

	printf("\033[00;32;40m");
	fflush(stdout);

	for (i=0;i<ips_count;i++)	{
		term.goto_xy(PANEL_LEFT_X,PANEL_LEFT_Y+i);
		for (j=1;j<LEFT_PANEL;j++) printf(" ");
		fflush(stdout);
		}
	
	for (i=0;i<dst_count;i++)	{
		term.goto_xy(PANEL_RIGHT_X, PANEL_RIGHT_Y +i);
      for (j=1;j<RIGHT_PANEL;j++) printf(" ");
      fflush(stdout);
		}
}

void Display::display_header()	{

	unsigned int i;
	
	for (i=1;i<term.rows*term.cols;i++)
	    printf(" ");

	printf("\033[?25l"); // ustawia kolor i chowa kursor

	term.goto_xy(1,HEADER_BAR_Y);
	for (i=1;i<term.cols;i++)  printf(" ");
	term.goto_xy(1,HEADER_BAR_Y);
	
	printf("       \033[01;33;40mLTCC\033[00;30;40m - \033[01;33;40mL\033[00;37;40mocal \033[01;33;40mT\033[00;37;40mcp \033[01;33;40mC\033[00;37;40montrol \033[01;33;40mC\033[00;37;40menter  version 1.0.2  pablo@ae.krakow.pl\033[00;30;40m      ");

	term.goto_xy(1,OPTIONS_BAR_Y);
	for (i=1;i<term.cols;i++)  printf(" ");
	term.goto_xy(1,OPTIONS_BAR_Y);
	
   printf("\033[00;30;44m     [\033[01;33;44mA\033[00;30;44m]ctive   [\033[01;33;44mK\033[00;30;44m]ill   [\033[01;33;44mL\033[00;30;44m]evel   [\033[01;33;44mS\033[00;30;44m]can timeout   Kill [\033[01;33;44mT\033[00;30;44m]imeout   [\033[01;33;44mQ\033[00;30;44m]uit      ");
	fflush(stdout);
										
}


void Display::status_bar_display_text(char * text)	{
	
	unsigned int i;

	term.goto_xy(1,term.rows-1);
	printf("\033[00;30;46m");
	fflush(stdout);
	
	for (i=1;i<term.cols;i++)	
		printf(" ");
		
	term.goto_xy(3,term.rows-1);
	printf("%s",text);
	fflush(stdout);	
	
}

void Display::status_bar_display ()	{
	
	status_bar_display_text(status_bar_text);
	
}

/*
 * function : status_bar
 * display status bar with message at the bottom of the screen
 */
void Display::status_bar(char * message)	{

	strncpy(status_bar_text,message,STATUS_BAR_SIZE);
	status_bar_display();
	
}

void Display::status_bar_append(char * message)	{

	char temp [STATUS_BAR_SIZE];
	snprintf(temp,STATUS_BAR_SIZE,"%s%s",status_bar_text,message);
	status_bar_display_text(temp);

}

/*
 * function : close_graph
 * restore terminal settings
 */
void Display::close_graph ()	{
printf("\033[00;37;40m\033[?25h\n");
fflush(stdout);
term.term_rest();
}
