#define _TCPCC_H

#include <net/if.h>
//#include <net/if_packet.h>
#include <net/ethernet.h>
//#include <netpacket/packet.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>

#include "global.h"

#define MAXPACKET 512
#define ETHER_HEADER 0x0e
#define MAX_DESTS 130

#define MAX_TEMP_IPS	2000

typedef unsigned int u32;
typedef unsigned short u16;
typedef unsigned char u8;
      
void sig_alarm(int);

class Ipeki {
	public:
		unsigned long ip; // network long address
		unsigned int sports [MAX_DESTS]; // network short port addresses
		unsigned int dports [MAX_DESTS]; // network short port addresses
		unsigned long dests [MAX_DESTS]; // network long address
		unsigned int p_count;
		unsigned int status[MAX_DESTS]; // 0=alive, 1=killed
	};

class Ipeki_temp	{
	public:
		unsigned long ip;
		unsigned int sports;
		unsigned int dports;
		unsigned long dests;
	};

class Tcpcc {
	private:
//		char packet [MAXPACKET];
		struct ifreq ifr;
		struct iphdr * ip;
		struct tcphdr * tcp;
		int sockfd;
		char interface [16];

		unsigned long local [255];
		unsigned long netmask, broadcast, myip;
		
		Ipeki_temp temp_ips [MAX_TEMP_IPS];
		unsigned int temp_ips_count;
		
		void store_packet();
		
		u16 tcp_checksum(u16 *, int, struct in_addr, struct in_addr);
		u16 checksum(u16 *ptr, int n);
		
	public:
		Ipeki ips [255];
		unsigned int ip_count;

		int initialize (char *, char *, char *);
		unsigned int find_active (int);
		int generate_ips_struct();

		void translate (char [LEFT_PANEL][255], char [RIGHT_PANEL][255], int *, int *, int);
		int killhim(unsigned long, unsigned int, unsigned long, unsigned int, int, int);
		int prepare2killint (int, int, int, int);
		int prepare2kill (unsigned long, unsigned int, unsigned long, unsigned int, int, int);
	};
